package ehu.student.collections;

import java.util.TreeMap;
import java.util.TreeSet;

/**
 * Ejemplo de uso de TreeMap<Integer, TreeSet<String>>
 * 
 * El usuario introduce tantas palabras como desee.
 * El programa presenta esas palabras, en orden alfabetico, 
 * sin repeticiones, agrupadas segn longitudes crecientes.
 */
public class AgrupadorPalabrasPorLongitud {

    public static void main(String[] args){
        acm.io.IODialog dialog = new acm.io.IODialog();

        /*
         * Logitudes de las palabras leidas,
         * junto con las palabras leidas de cada longitud
         */
        TreeMap<Integer, TreeSet<String>> map = 
            new TreeMap<Integer, TreeSet<String>>();

        while(dialog.readBoolean("Continuar?")){
            String w = dialog.readLine("Sigte palabra ?");
            int longitud = w.length();

            /*
             * Ver cual es el conjunto de palabras de esa longitud
             * leidas hasta ahora:
             *     puede ser "null"...
             */
            TreeSet<String> set = map.get(longitud);/*@\label{AgrupadorPalabrasPorLongitud.get}@*/
            if (set == null){/*@\label{AgrupadorPalabrasPorLongitud.if}@*/
                /* ... si no se ha leido ninguna palabra con esa "longitud" */
                set =  new TreeSet<String>();
                /* el conjunto de palabras correspondiente a esa "longitud" */
                map.put(longitud, set); /*@\label{AgrupadorPalabrasPorLongitud.put}@*/
            }
            /* 
             * en todo caso, la palabra se aade al conjunto
             * de palabras con esa "longitud" 
             */
            set.add(w);/*@\label{AgrupadorPalabrasPorLongitud.incr}@*/
        }
        System.out.println(map.toString());
        System.exit(0);
    }
}
