package ehu.student.collections;

import java.util.ArrayList;

/**
 * Una clase para ordenar listas de cartas.
 */
public class BubbleSort4ArrayListCartaBarajaInmutable {

    /**
     * Se reorganiza la "lista" de cartas recolocando sus elementos.
     * Quedan ordenados segun palos; dentro de cada palo segun figuras
     */
    public void ordenar(ArrayList<CartaBarajaInmutable> lista)
    {
        boolean hayElementosResituados;
        do {/*@\label{BubbleSort.while.a}@*/
            hayElementosResituados = false;                        
            /* comparar cada carta con la siguiente... */
            for (int i = 0; i < lista.size()-1; i++) /*@\label{BubbleSort.for.a}@*/
                {
                    CartaBarajaInmutable cartaEnI = lista.get(i);
                    CartaBarajaInmutable steCarta = lista.get(i+1);
                    /* ... y si es preciso, intercambiar sus posiciones */
                    if (esMenor(steCarta, cartaEnI)){/*@\label{BubbleSort.if}@*/
                        lista.set(i+1, cartaEnI);
                        lista.set(i, steCarta);
                        hayElementosResituados = true;
                    }
                }                                          /*@\label{BubbleSort.for.z}@*/
            /* 
             * Si hay hayElementosResituados == false, entonces
             * cada carta esta situada en la posicion que le corresponde
             */
        } while (hayElementosResituados);/*@\label{BubbleSort.while.z}@*/
    }
        
    /**
     * Devuelve "true" si la carta "x" debe ir situada antes que la "y";
     * "false" en caso contrario.
     */
    public boolean esMenor(CartaBarajaInmutable x, CartaBarajaInmutable y)
    {
        boolean r =
            (x.getSuit() < y.getSuit()) ||
            (x.getSuit() == y.getSuit() 
             && x.getFigure() < y.getFigure());
        return r;
    }
}
