package ehu.student.collections;

import java.util.TreeMap;

/**
 * Ejemplo de uso de TreeMap<String, Integer>.
 * 
 * El usuario introduce tantas palabras como desee.
 * El programa presenta esas palabras, en orden alfabetico
 * y sin repeticiones, junto con la frecuencia de cada una:
 * cuantas veces ha sido leida.
 */
public class ContadorFrecuenciasDePalabras {

    public static void main(String[] args)
    {
        acm.io.IODialog dialog = new acm.io.IODialog();

        /* Para memorizar cada palabra y cuantas veces aparece */
        TreeMap<String, Integer> map = 
            new TreeMap<String, Integer>();           /*@\label{Frecuencias.new}@*/

        while(dialog.readBoolean("Continuar?")){
            String w = dialog.readLine("Sigte palabra ?");

            /* Evaluar cuantas veces ha sido leida antes */
            Integer numeroDeApariciones = map.get(w); /*@\label{Frecuencias.get}@*/

            /* 
             * numeroDeApariciones es un objeto: 
             *      podria ser "null"!... */
            if (numeroDeApariciones == null){         /*@\label{Frecuencias.if}@*/
                /* ...si la palabra se lee por primera vez! */
                numeroDeApariciones = 0;
            }                              /*@\label{Frecuencias.if.z}@*/
            /* sea lo que sea, se cuanta una vez mas */
            numeroDeApariciones = numeroDeApariciones+1;/*@\label{Frecuencias.incr}@*/

            /* cambiar el valor asociado a la palabra */
            map.put(w, numeroDeApariciones);          /*@\label{Frecuencias.put}@*/
        }
        System.out.println(map.toString());/*@\label{Frecuencias.print}@*/
        System.exit(0);
    }
}
