package ehu.student.collections;

import java.util.TreeSet;
/**
 * Calculo de los primeros(menores) y ultimos(mayores) elementos de un conjunto.
 */
public class SeleccionadorDeElementosDeUnConjunto 
{
    /**
     * Devuelve un nuevo conjunto con los K PRIMEROS elementos de "conjunto".
     * Si no tiene K elementos, el resultado contiene todos sus elementos.
     */
    public TreeSet<String> crearConjuntoConMenores(int K, 
                                                   TreeSet<String> conjunto)
    {
        TreeSet<String> resultado = new TreeSet<String>();
        /* Para cada elemento del conjunto dado...*/
        for (String x: conjunto){
            resultado.add(x); /* ese elemento se aade al resultado */
            if (resultado.size() == K){
                /* ... ya tiene los K menores del conjunto original */
                break; // fin del bucle!
            }
        }
        return resultado;
    }
    
    /**
     * Devuelve un nuevo conjunto con los K ULTIMOS elementos de "conjunto".
     * Si no tiene K elementos, el resultado contiene todos sus elementos.
     */
    public TreeSet<String> crearConjuntoConMayores(int K, 
                                                   TreeSet<String> conjunto)
    {
        TreeSet<String> resultado = new TreeSet<String>();
        /* Para cada elemento del conjunto dado...*/
        for (String x: conjunto){
            resultado.add(x); /* ese elemento se aade al resultado */
            if (resultado.size() > K){
                /* ... ya tiene K+1 elementos: hay que eliminar el menor */
                String v = resultado.first();// v es la primera(menor)
                resultado.remove(v);      // eliminar el elemento v de resultado 
            }
        }
        return resultado;
    }
}
